# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from dataspeed_pds_msgs/Status.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import dataspeed_pds_msgs.msg
import std_msgs.msg

class Status(genpy.Message):
  _md5sum = "fd33646796ccd4afc121c615c81ae551"
  _type = "dataspeed_pds_msgs/Status"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """Header header

# Channels (12|24|36|48)
Channel[] chan

# Mode status
Mode mode

# Script status
Script script

# Master/Slave common values (inverter/temperature/voltage)
Common master
Common[] slave

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: dataspeed_pds_msgs/Channel
# Current (Amps)
float32 current

# Status
uint8 status
uint8 OFF=0
uint8 ON=1
uint8 NO_LOAD=2
uint8 BAD_RELAY=3
uint8 BAD_FUSE=4
uint8 OVER_CURRENT=5

================================================================================
MSG: dataspeed_pds_msgs/Mode
# The actual value of the mode enum.
uint8 mode

# An enumeration of the possible values of the mode enum.
uint8 AUTO=0
uint8 MANUAL=1
uint8 VALET=2
================================================================================
MSG: dataspeed_pds_msgs/Script
# The actual value of the script enum.
uint8 script

# An enumeration of the possible values of the script enum.
uint8 NONE=0
uint8 STARTUP=1
uint8 SHUTDOWN=2
================================================================================
MSG: dataspeed_pds_msgs/Common
# Inverter (13th channel)
Inverter inverter

# Temperatures
Temperature temp

# Voltage
float32 voltage

================================================================================
MSG: dataspeed_pds_msgs/Inverter
bool request
bool status
bool overload
bool overtemp

================================================================================
MSG: dataspeed_pds_msgs/Temperature
# Temperature (C)
float32[3] internal
float32[4] external
"""
  __slots__ = ['header','chan','mode','script','master','slave']
  _slot_types = ['std_msgs/Header','dataspeed_pds_msgs/Channel[]','dataspeed_pds_msgs/Mode','dataspeed_pds_msgs/Script','dataspeed_pds_msgs/Common','dataspeed_pds_msgs/Common[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,chan,mode,script,master,slave

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Status, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.chan is None:
        self.chan = []
      if self.mode is None:
        self.mode = dataspeed_pds_msgs.msg.Mode()
      if self.script is None:
        self.script = dataspeed_pds_msgs.msg.Script()
      if self.master is None:
        self.master = dataspeed_pds_msgs.msg.Common()
      if self.slave is None:
        self.slave = []
    else:
      self.header = std_msgs.msg.Header()
      self.chan = []
      self.mode = dataspeed_pds_msgs.msg.Mode()
      self.script = dataspeed_pds_msgs.msg.Script()
      self.master = dataspeed_pds_msgs.msg.Common()
      self.slave = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.chan)
      buff.write(_struct_I.pack(length))
      for val1 in self.chan:
        _x = val1
        buff.write(_get_struct_fB().pack(_x.current, _x.status))
      _x = self
      buff.write(_get_struct_6B().pack(_x.mode.mode, _x.script.script, _x.master.inverter.request, _x.master.inverter.status, _x.master.inverter.overload, _x.master.inverter.overtemp))
      buff.write(_get_struct_3f().pack(*self.master.temp.internal))
      buff.write(_get_struct_4f().pack(*self.master.temp.external))
      _x = self.master.voltage
      buff.write(_get_struct_f().pack(_x))
      length = len(self.slave)
      buff.write(_struct_I.pack(length))
      for val1 in self.slave:
        _v1 = val1.inverter
        _x = _v1
        buff.write(_get_struct_4B().pack(_x.request, _x.status, _x.overload, _x.overtemp))
        _v2 = val1.temp
        buff.write(_get_struct_3f().pack(*_v2.internal))
        buff.write(_get_struct_4f().pack(*_v2.external))
        _x = val1.voltage
        buff.write(_get_struct_f().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.chan is None:
        self.chan = None
      if self.mode is None:
        self.mode = dataspeed_pds_msgs.msg.Mode()
      if self.script is None:
        self.script = dataspeed_pds_msgs.msg.Script()
      if self.master is None:
        self.master = dataspeed_pds_msgs.msg.Common()
      if self.slave is None:
        self.slave = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.chan = []
      for i in range(0, length):
        val1 = dataspeed_pds_msgs.msg.Channel()
        _x = val1
        start = end
        end += 5
        (_x.current, _x.status,) = _get_struct_fB().unpack(str[start:end])
        self.chan.append(val1)
      _x = self
      start = end
      end += 6
      (_x.mode.mode, _x.script.script, _x.master.inverter.request, _x.master.inverter.status, _x.master.inverter.overload, _x.master.inverter.overtemp,) = _get_struct_6B().unpack(str[start:end])
      self.master.inverter.request = bool(self.master.inverter.request)
      self.master.inverter.status = bool(self.master.inverter.status)
      self.master.inverter.overload = bool(self.master.inverter.overload)
      self.master.inverter.overtemp = bool(self.master.inverter.overtemp)
      start = end
      end += 12
      self.master.temp.internal = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 16
      self.master.temp.external = _get_struct_4f().unpack(str[start:end])
      start = end
      end += 4
      (self.master.voltage,) = _get_struct_f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.slave = []
      for i in range(0, length):
        val1 = dataspeed_pds_msgs.msg.Common()
        _v3 = val1.inverter
        _x = _v3
        start = end
        end += 4
        (_x.request, _x.status, _x.overload, _x.overtemp,) = _get_struct_4B().unpack(str[start:end])
        _v3.request = bool(_v3.request)
        _v3.status = bool(_v3.status)
        _v3.overload = bool(_v3.overload)
        _v3.overtemp = bool(_v3.overtemp)
        _v4 = val1.temp
        start = end
        end += 12
        _v4.internal = _get_struct_3f().unpack(str[start:end])
        start = end
        end += 16
        _v4.external = _get_struct_4f().unpack(str[start:end])
        start = end
        end += 4
        (val1.voltage,) = _get_struct_f().unpack(str[start:end])
        self.slave.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.chan)
      buff.write(_struct_I.pack(length))
      for val1 in self.chan:
        _x = val1
        buff.write(_get_struct_fB().pack(_x.current, _x.status))
      _x = self
      buff.write(_get_struct_6B().pack(_x.mode.mode, _x.script.script, _x.master.inverter.request, _x.master.inverter.status, _x.master.inverter.overload, _x.master.inverter.overtemp))
      buff.write(self.master.temp.internal.tostring())
      buff.write(self.master.temp.external.tostring())
      _x = self.master.voltage
      buff.write(_get_struct_f().pack(_x))
      length = len(self.slave)
      buff.write(_struct_I.pack(length))
      for val1 in self.slave:
        _v5 = val1.inverter
        _x = _v5
        buff.write(_get_struct_4B().pack(_x.request, _x.status, _x.overload, _x.overtemp))
        _v6 = val1.temp
        buff.write(_v6.internal.tostring())
        buff.write(_v6.external.tostring())
        _x = val1.voltage
        buff.write(_get_struct_f().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.chan is None:
        self.chan = None
      if self.mode is None:
        self.mode = dataspeed_pds_msgs.msg.Mode()
      if self.script is None:
        self.script = dataspeed_pds_msgs.msg.Script()
      if self.master is None:
        self.master = dataspeed_pds_msgs.msg.Common()
      if self.slave is None:
        self.slave = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.chan = []
      for i in range(0, length):
        val1 = dataspeed_pds_msgs.msg.Channel()
        _x = val1
        start = end
        end += 5
        (_x.current, _x.status,) = _get_struct_fB().unpack(str[start:end])
        self.chan.append(val1)
      _x = self
      start = end
      end += 6
      (_x.mode.mode, _x.script.script, _x.master.inverter.request, _x.master.inverter.status, _x.master.inverter.overload, _x.master.inverter.overtemp,) = _get_struct_6B().unpack(str[start:end])
      self.master.inverter.request = bool(self.master.inverter.request)
      self.master.inverter.status = bool(self.master.inverter.status)
      self.master.inverter.overload = bool(self.master.inverter.overload)
      self.master.inverter.overtemp = bool(self.master.inverter.overtemp)
      start = end
      end += 12
      self.master.temp.internal = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 16
      self.master.temp.external = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=4)
      start = end
      end += 4
      (self.master.voltage,) = _get_struct_f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.slave = []
      for i in range(0, length):
        val1 = dataspeed_pds_msgs.msg.Common()
        _v7 = val1.inverter
        _x = _v7
        start = end
        end += 4
        (_x.request, _x.status, _x.overload, _x.overtemp,) = _get_struct_4B().unpack(str[start:end])
        _v7.request = bool(_v7.request)
        _v7.status = bool(_v7.status)
        _v7.overload = bool(_v7.overload)
        _v7.overtemp = bool(_v7.overtemp)
        _v8 = val1.temp
        start = end
        end += 12
        _v8.internal = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
        start = end
        end += 16
        _v8.external = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=4)
        start = end
        end += 4
        (val1.voltage,) = _get_struct_f().unpack(str[start:end])
        self.slave.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
_struct_4B = None
def _get_struct_4B():
    global _struct_4B
    if _struct_4B is None:
        _struct_4B = struct.Struct("<4B")
    return _struct_4B
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
_struct_6B = None
def _get_struct_6B():
    global _struct_6B
    if _struct_6B is None:
        _struct_6B = struct.Struct("<6B")
    return _struct_6B
_struct_f = None
def _get_struct_f():
    global _struct_f
    if _struct_f is None:
        _struct_f = struct.Struct("<f")
    return _struct_f
_struct_fB = None
def _get_struct_fB():
    global _struct_fB
    if _struct_fB is None:
        _struct_fB = struct.Struct("<fB")
    return _struct_fB
