// Auto-generated. Do not edit!

// (in-package dataspeed_pds_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Channel = require('./Channel.js');
let Mode = require('./Mode.js');
let Script = require('./Script.js');
let Common = require('./Common.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class Status {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.chan = null;
      this.mode = null;
      this.script = null;
      this.master = null;
      this.slave = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('chan')) {
        this.chan = initObj.chan
      }
      else {
        this.chan = [];
      }
      if (initObj.hasOwnProperty('mode')) {
        this.mode = initObj.mode
      }
      else {
        this.mode = new Mode();
      }
      if (initObj.hasOwnProperty('script')) {
        this.script = initObj.script
      }
      else {
        this.script = new Script();
      }
      if (initObj.hasOwnProperty('master')) {
        this.master = initObj.master
      }
      else {
        this.master = new Common();
      }
      if (initObj.hasOwnProperty('slave')) {
        this.slave = initObj.slave
      }
      else {
        this.slave = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Status
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [chan]
    // Serialize the length for message field [chan]
    bufferOffset = _serializer.uint32(obj.chan.length, buffer, bufferOffset);
    obj.chan.forEach((val) => {
      bufferOffset = Channel.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [mode]
    bufferOffset = Mode.serialize(obj.mode, buffer, bufferOffset);
    // Serialize message field [script]
    bufferOffset = Script.serialize(obj.script, buffer, bufferOffset);
    // Serialize message field [master]
    bufferOffset = Common.serialize(obj.master, buffer, bufferOffset);
    // Serialize message field [slave]
    // Serialize the length for message field [slave]
    bufferOffset = _serializer.uint32(obj.slave.length, buffer, bufferOffset);
    obj.slave.forEach((val) => {
      bufferOffset = Common.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Status
    let len;
    let data = new Status(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [chan]
    // Deserialize array length for message field [chan]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.chan = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.chan[i] = Channel.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [mode]
    data.mode = Mode.deserialize(buffer, bufferOffset);
    // Deserialize message field [script]
    data.script = Script.deserialize(buffer, bufferOffset);
    // Deserialize message field [master]
    data.master = Common.deserialize(buffer, bufferOffset);
    // Deserialize message field [slave]
    // Deserialize array length for message field [slave]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.slave = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.slave[i] = Common.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += 5 * object.chan.length;
    length += 36 * object.slave.length;
    return length + 46;
  }

  static datatype() {
    // Returns string type for a message object
    return 'dataspeed_pds_msgs/Status';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'fd33646796ccd4afc121c615c81ae551';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    Header header
    
    # Channels (12|24|36|48)
    Channel[] chan
    
    # Mode status
    Mode mode
    
    # Script status
    Script script
    
    # Master/Slave common values (inverter/temperature/voltage)
    Common master
    Common[] slave
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: dataspeed_pds_msgs/Channel
    # Current (Amps)
    float32 current
    
    # Status
    uint8 status
    uint8 OFF=0
    uint8 ON=1
    uint8 NO_LOAD=2
    uint8 BAD_RELAY=3
    uint8 BAD_FUSE=4
    uint8 OVER_CURRENT=5
    
    ================================================================================
    MSG: dataspeed_pds_msgs/Mode
    # The actual value of the mode enum.
    uint8 mode
    
    # An enumeration of the possible values of the mode enum.
    uint8 AUTO=0
    uint8 MANUAL=1
    uint8 VALET=2
    ================================================================================
    MSG: dataspeed_pds_msgs/Script
    # The actual value of the script enum.
    uint8 script
    
    # An enumeration of the possible values of the script enum.
    uint8 NONE=0
    uint8 STARTUP=1
    uint8 SHUTDOWN=2
    ================================================================================
    MSG: dataspeed_pds_msgs/Common
    # Inverter (13th channel)
    Inverter inverter
    
    # Temperatures
    Temperature temp
    
    # Voltage
    float32 voltage
    
    ================================================================================
    MSG: dataspeed_pds_msgs/Inverter
    bool request
    bool status
    bool overload
    bool overtemp
    
    ================================================================================
    MSG: dataspeed_pds_msgs/Temperature
    # Temperature (C)
    float32[3] internal
    float32[4] external
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Status(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.chan !== undefined) {
      resolved.chan = new Array(msg.chan.length);
      for (let i = 0; i < resolved.chan.length; ++i) {
        resolved.chan[i] = Channel.Resolve(msg.chan[i]);
      }
    }
    else {
      resolved.chan = []
    }

    if (msg.mode !== undefined) {
      resolved.mode = Mode.Resolve(msg.mode)
    }
    else {
      resolved.mode = new Mode()
    }

    if (msg.script !== undefined) {
      resolved.script = Script.Resolve(msg.script)
    }
    else {
      resolved.script = new Script()
    }

    if (msg.master !== undefined) {
      resolved.master = Common.Resolve(msg.master)
    }
    else {
      resolved.master = new Common()
    }

    if (msg.slave !== undefined) {
      resolved.slave = new Array(msg.slave.length);
      for (let i = 0; i < resolved.slave.length; ++i) {
        resolved.slave[i] = Common.Resolve(msg.slave[i]);
      }
    }
    else {
      resolved.slave = []
    }

    return resolved;
    }
};

module.exports = Status;
